###################################################
### chunk number 1: set_seed
###################################################
#line 23 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
set.seed(123)


###################################################
### chunk number 2: as_mmap
###################################################
#line 115 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
library(mmap)

r <- rnorm(20e6)
gc()

r <- as.mmap(r)
r

gc()


###################################################
### chunk number 3: mmap_extract
###################################################
#line 143 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
r[1:10]
r[87643]
head(r)
tail(r)
length(r)
r[1:10] <- 1:10
r[87643] <- 3.14159265
head(r)
r[87643]
munmap(r)


###################################################
### chunk number 4: types1
###################################################
#line 215 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
tmp <- tempfile()

writeBin(1:10L, tmp, size=1)  # write int as 1 byte
readBin(tmp, integer(), size=1, signed=TRUE, n=10) # read back in to verify

file.info(tmp)$size  # only 10 bytes on disk


###################################################
### chunk number 5: mmap_int8
###################################################
#line 245 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
m <- mmap(file=tmp, mode=int8())
m[]
nbytes(m)
munmap(m)


###################################################
### chunk number 6: types
###################################################
#line 343 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
# write out a vector of upper case letters as a char * array
writeBin(LETTERS, tmp)  
let <- mmap(tmp, char(1))
let
let[]
munmap(let)
#
# view the data as a series of bytes instead, using raw()
let <- mmap(tmp, raw())
let[]
munmap(let)
#
# view the data as a series of short integers 
let <- mmap(tmp, int16())
let[]
munmap(let)


###################################################
### chunk number 7: struct
###################################################
#line 377 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
# 2-byte (int16)
# 4-byte (int32 or integer)
# 8-byte float (real64 or double)
record.type <- struct(short=int16(),int=int32(),double=real64())
record.type
nbytes(record.type) # 14 bytes in total


###################################################
### chunk number 8: struct_create
###################################################
#line 385 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
writeBin(rep(raw(nbytes(record.type)), 100), tmp)
m <- mmap(tmp, record.type)
#ids <- sapply(1:100, function(X) paste(sample(letters,3),collapse=""))
m[] <- list(1:100L, sample(1e6,100), rnorm(100))#, ids)


###################################################
### chunk number 9: struct_extract
###################################################
#line 394 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
#m <- mmap(tmp, record.type)
m[1]
m[1:3]
m[1:3, "short"]
length(m)


###################################################
### chunk number 10: struct_df
###################################################
#line 411 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
extractFUN(m) <- function(X) do.call(data.frame, X)
extractFUN(m)


###################################################
### chunk number 11: struct_df_ex
###################################################
#line 423 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
m[1]
m[2:5]
m[2:5, "double"] # note that subset is on mmap, returning a new data.frame
m[2:5, 2]
m[1:9][,"double"]  # second brackets act on d.f., as the first is on the mmap


###################################################
### chunk number 12: struct_df_ex_cleanup
###################################################
#line 431 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
munmap(m)


###################################################
### chunk number 13: logical_test
###################################################
#line 501 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
one.to.onemil <- 1:1e6L
writeBin(1:1e6L, tmp)
m <- mmap(tmp, int32())
str(m < 100)
str(which(one.to.onemil < 100))
system.time(m < 100)
system.time(which(one.to.onemil < 100))


###################################################
### chunk number 14: logical_cleanup
###################################################
#line 511 "d:/Rcompile/CRANpkg/local/2.12/mmap/inst/doc/mmap.Rnw"
munmap(m)
rm(one.to.onemil)


